//modified:2003.01.22@21:09 by Alex

//Project: TI-Server v3

{$DEFINE TiSim}                   // TI-Simulator benutzen
  {$DEFINE TiSimUseCom}           //   TI-Simulator soll Daten ber ser. Schnittstelle senden
{$UNDEF  AutoCreateTIs}           // zum Testen der Auslastung des Servers, wenn mehrere TIs angemeldet sind (meldet automatisch bis zu 3 TIs an)
{$UNDEF  LongerBreakWhenReceived} // verlngert das Empfangstimeout, wenn inzwischen Daten empfangen werden
{$UNDEF  LogInitStrings}          // sollen die InitStrings im LogFile auftauchen?

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls, ExtCtrls,
  WSocket, WSocketS, VaClasses, VaComm,
  MM_Timer, UnitTypes, TIobject, UnitMy, AppEvnts;

type
  TForm1 = class(TForm)
    MemoMainEventLog: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    ImageStatus: TImage;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LabelImageMax: TLabel;
    Label7: TLabel;
    EditNumOfTIs: TEdit;
    EditUpTime: TEdit;
    Track: TTrackBar;
    UpDownStatus: TUpDown;
    Com: TVaComm;
    HRTimer: TMMTimer;
    MainMenu: TMainMenu;
    Datei1: TMenuItem;
    MenuExit: TMenuItem;
    Server1: TMenuItem;
    StartStop: TMenuItem;
    N1: TMenuItem;
    MMConfig: TMenuItem;
    TiSim1: TMenuItem;
    MMShow: TMenuItem;
    MMHide: TMenuItem;
    Info1: TMenuItem;
    MMServerVersion: TMenuItem;
    TimerUptime: TTimer;
    AppEvents: TApplicationEvents;
    LabelImageWidth: TLabel;
    ImageResent: TImage;
    LabelStatus: TLabel;
    procedure HighLevelLoop;
    procedure StartStopClick(Sender: TObject);
    procedure HRTimerTimer(Sender: TObject; Time: Cardinal);
    procedure Delay(msec:integer);
    procedure ReceivePacket(msec:integer);
    procedure SendPacket(an:byte; id:byte; mpinfo: byte; daten:string);
    procedure CheckForPacket;
    procedure TXENSend;
    procedure TXENReceive;
    procedure Log(text:string);
    procedure LogE(text:string);
    procedure MainLog(text:string;tofile:boolean);
    procedure FinishedSending(Sender: TObject);
    procedure ComRxChar(Sender: TObject; Count: Integer);
    procedure MenuExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DoCRC8(var crc8:byte;x:byte);
    function  GetFreeAddr(forwhom:byte):byte;
    procedure MMShowClick(Sender: TObject);
    procedure MMHideClick(Sender: TObject);
    procedure UnregisterMe(index:integer);
    procedure MMConfigClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerUptimeTimer(Sender: TObject);
    procedure TrackChange(Sender: TObject);
    procedure ProcessRcvBuffer;
    procedure AppEventsException(Sender: TObject; E: Exception);
    procedure ClearImage(Image:TImage);
    procedure UpDownStatusClick(Sender: TObject; Button: TUDBtnType);
    procedure MMServerVersionClick(Sender: TObject);
    procedure KickUser(index:integer);
    function  ReadLnBoolean(var myfile:textfile):boolean;
    procedure WriteLnBoolean(var myfile:textfile;a:boolean);
    function  AlreadyRegistered(name:string):boolean;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    PauseTXEN2r : byte;    //Pause in msec wenn txen auf Lesen gesetzt wird
    PauseTXEN2w : byte;    //Pause in msec wenn txen auf Schreiben gesetzt wird
    PauseRegis  : word;    //Timeout in msec nach Anmeldefreigabe
    PauseRecv   : word;    //Timeout in msec nach Sendefreigabe
    packetinitstr:string;  //Zeichen, das vor einem Paket steht
    PauseAfterSendShortPacket:
                  integer; //Pause nach dem Senden eines Steuerpaketes
    PauseAfterSendLongPacket:
                  integer; //Pause nach dem Senden eines Paketes mit Inhalt
    MaxLogLines : integer;
    MaxPacketLen: integer; //maximale Lnge der Daten in einem Paket (single packet)
    RunServer   : boolean; //true solange der Server luft
    KickTIAfterUnreplied:  //Anzahl der Nichtantworten, nach denen ein TI gekickt wird
                  integer;
    MaxNumofMails:         //maximale Anzahl der Mails, die per POP3 abgerufen werden
                  integer;
    MaxSizeofMails:        //maximale Gre der Mails, die per POP3 abgerufen werden
                  integer;
    feedback    : array of TFeedback; //frs Feedback
    DrawResentFor: integer;//fr welchen TI resent gezeichnet werden soll
    totaluptime : integer; //total uptime
  end;

var
  Form1       : TForm1;
  TIT         : array of TProcess;        //TI class
  logfile     : textfile;
  wait        : boolean; //weiter warten = true
  packetrcvd  : boolean; //Paket wurde empfangen = true
  stillsending: boolean; //wenn Sendepuffer nicht leer = true
  rcvbuffer   : string;  //speichert empfangene Daten zwischen
  packet      : string;  //letztempfangenes Paket
  addrgiven   : array[0..255] of boolean; //vergebene Adressen
  addr2TI     : array[0..255] of byte;    //Umsetzungstabelle addr -> TI  (0 = kein TI hat diese Adresse)
  firstaddr   : byte;                     //niedrigste vergebene Adresse (fr High Level Loop, hier mu ich ja wissen, welche Adressen ich sendefreigeben mu)
  lastaddr    : byte;                     //hchste vergebene Adresse    ( " )
  userdata    : array of Tuserdata;
  SwitchedTXEN2Receive
              : boolean; //ob wir gerade auf Empfangen geschaltet haben
  uptime      : integer;
  PacketInitStrRcvd      //ob wir schon ein PacketInitStr empfangen haben
              : boolean;
  statusxpos  : integer; //x-Position des Status-Schreibers
  resentposx  : integer; //x-Position des Resent-Schreibers
  TXEN        : TTXEN;   //zeigt an, ob TXEN auf Senden oder Empfangen steht

implementation

uses UnitTiSim, UnitConfig;

{$R *.DFM}


procedure TForm1.StartStopClick(Sender: TObject);
//starts resp. stops the server (high level protocol)
begin
  if MainMenu.Items[1].Items[0].Caption='&Start' then begin
    MainMenu.Items[1].Items[0].Caption:='&Stop';
    firstaddr := 255;
    lastaddr  := 0;
    RunServer := true;
    MemoMainEventLog.Text:='WICHTIGE EREIGNISSE:'#13#10;
    {$IFDEF TiSim}
      FormTiSim.Show;
      FormTiSim.Enabled:=true;
    {$ENDIF}
    TimerUptime.Enabled:=true;
    HighLevelLoop;
  end else begin
    MainMenu.Items[1].Items[0].Caption:='&Start';
    {$IFDEF TiSim}
      FormTiSim.Enabled:=false;
      FormTiSim.Hide;
    {$ENDIF}
    TimerUptime.Enabled:=false;
    RunServer:=false;
  end;
end;


////////////////////////////////////////////////////////////////////////////////
//
//                 ' W A I T I N G '   R O U T I N E S
//
procedure TForm1.Delay(msec:integer);
//wartet fr msec msec
begin
  if msec<=0 then exit;
  if loglevel>=llhigh then Log('wait '+inttostr(msec));
  HRTimer.Enabled:=false;
  HRTimer.Interval:=msec;
  wait:=true;
  HRTimer.Enabled:=true;
  while wait do begin
    if Application.Terminated then exit;
    Application.ProcessMessages;
  end;
end;


procedure TForm1.ReceivePacket(msec:integer);
//wartet max. msec msec auf den Empfang eines Paketes
{$IFDEF TiSim}
var
  a : string;
{$ENDIF}
begin
  SwitchedTXEN2Receive:=true;
  if loglevel>=llhigh then Log('NOTE : receive-wait '+inttostr(msec));
  HRTimer.Enabled:=false;
  HRTimer.Interval:=msec;
  wait:=true;
  packetrcvd:=false;
  HRTimer.Enabled:=true;
  {$IFDEF TiSim}
    a:=FormTiSim.SendToServer;
    if a<>'' then begin
      rcvbuffer:=rcvbuffer+a;
      {$IFDEF TiSimUseCom}
      Com.SetDTRState(true xor Form2.RBCSDTRhighlow.Checked);  //set TXEN to send
      Com.WriteText(packetinitstr+rcvbuffer);
      Log(Format('TiSim SENT %d byte: %s',[length(a),EncodeText(rcvbuffer)]));
      Com.SetDTRState(false xor Form2.RBCSDTRhighlow.Checked); //set TXEN to receive
      ProcessRcvBuffer;
      {$ENDIF}
    end;
  {$ENDIF}
  while wait and not packetrcvd do begin
    if Application.Terminated then exit;
    Application.ProcessMessages;
  end;
  if not packetrcvd and (loglevel>=llhigh) then Log('NOTE : receive timeout');
end;


procedure TForm1.HRTimerTimer(Sender: TObject; Time: Cardinal);
//delay vorbei
begin
  if loglevel=llhighest then Log('TIMER');
  wait:=false;
end;
//                 ' W A I T I N G '   R O U T I N E S
//
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//
//                     H I G H   L E V E L   L O O P
//
//
procedure TForm1.HighLevelLoop;
//spult das HighLevelProtokoll ab, solange RunServer true ist
var
  whois2send : integer;
  i,j,y      : integer;
  oldtick    : integer;
  oldy1,oldy2: integer; //for scrolling of EKG
  lpacket    : TPacket;
  sendSF     : boolean; //send Sendefreigabe if this is true
const
  scrolloffset = 3;
begin
  //init high level protocol
  oldtick:=GetTickCount;
  try
    AssignFile(logfile,'./tiserverlog.txt');
    ReWrite(logfile);
  except
    ShowMessage('Could not open logfile for write access.');
    exit;
  end;
  Log('TI SERVER LOGFILE');
  Log(FormatDateTime('dddd, dd. mmmm yyyy @ hh:mm',now));
  Log('Abbreviations:'#13#10'SEND: this data is passed to comm'#13#10+
      'SENT: this data was sent to comm'#13#10'DROP: this'+
      ' data was received and dropped'#13#10'RCVD: this is a correct packet'+
      #13#10'TIMER: timer event'#13#10'(receive-)wait: waiting (for data)');
  Com.SetXonState(true);
  Com.SetBreakState(false);
  try
    Com.Open;
  except
    ShowMessage('Could not open port COM'+inttostr(Com.PortNum));
    CloseFile(logfile);
    exit;
  end;
  if loglevel>=lllow then Log('Port geffnet');
  for i:=0 to 3 do     addrgiven[i]:=true;
  for i:=4 to 253 do   addrgiven[i]:=false;
  for i:=254 to 255 do addrgiven[i]:=true;
  for i:=0 to high(userdata) do
    userdata[i].online:=false;
  SetLength(TIT,0);
  EditNumOfTIs.Text:='0';
  resentposx       :=0;
  DrawResentFor    :=0;
  oldy1            :=0; //makes compiler smile
  oldy2            :=0; //dito
  ClearImage(ImageResent);
  ImageStatus.Canvas.MoveTo(0,ImageStatus.Height);

  // execute high level protocol
  while RunServer do begin //uerstes while
    if FileSize(logfile)>MaxLogLines then begin
      CloseFile(logfile);
      if Form2.CheckCSDeleteOldLog.Checked then begin
        AssignFile(logfile,'./tiserverlog.txt');
      end else
        AssignFile(logfile,'./tiserverlog'+formatDateTime('yyyymmdd@hhnnss',now)+'.txt');
      ReWrite(logfile);
    end;
    if loglevel>=llnormal then Log('==== Schleife beginnt von vorne ====');

    // Statusanzeige  (frher: gimmick (Werbemtzchen))
    y:=(GetTickCount-oldtick) div UpDownStatus.Position;
    LabelStatus.Caption:=inttostr(GetTickCount-oldtick);
    with ImageStatus do begin
      Canvas.CopyMode:=cmmergecopy;                      //set copy mode
      Canvas.CopyRect(rect(0,0,Width,Height),Canvas,rect(ScrollOffset,0,width+ScrollOffset,height)); //scroll
      Canvas.FillRect(rect(width-ScrollOffset,0,width,Height));  //fill right with white

      Canvas.MoveTo(Width-2*ScrollOffset,Height-oldy2);  //move to start point
      Canvas.LineTo(Width-ScrollOffset,Height-oldy1);    //draw line
      Canvas.LineTo(Width,Height-y);                     //draw line
    end;
    oldy2  := oldy1;
    oldy1  := y;
    oldtick:=GetTickCount;

    {inc(statusxpos,1);
    if statusxpos>ImageStatus.Width then begin
      ClearImage(ImageStatus);
      statusxpos:=0;
    end;
    with ImageStatus do
      Canvas.LineTo(statusxpos,Height-(GetTickCount-oldtick) div UpDownStatus.Position);
    LabelStatus.Caption:=inttostr(GetTickCount-oldtick);
    oldtick:=GetTickCount;}
    //end of gimmick

    //TXEN
    TXENSend;
    //Anmeldefreigabe
    SendPacket(0,6,1,'');
    //TXEN
    TXENReceive;
    //GAP
    ReceivePacket(PauseRegis);
    //TXEN
    TXENSend;
    {$IFDEF AutoCreateTIs}//DEBUG                                                        !!! ACHTUNG !!!
    if (random>0.90) and (numofTIs<3) then begin
      packetrcvd:=true;
      packet:=#01#15#0#255#1+'ME      R'+#170;
    end;
    {$ENDIF}
    if packetrcvd then begin
      //Anmeldung durchfhren (dies wird sofort gemacht, da der Server gleich die Besttigung senden mu und solange nicht schon weitermachen kann)
      if length(packet)=19 then begin
        if not AlreadyRegistered(copy(packet,6,8)) then begin
          SetLength(TIT,length(TIT)+1);
          EditNumOfTIs.Text:=inttostr(length(TIT));
          TIT[high(TIT)]:=TProcess.Create(GetFreeAddr(high(TIT)),copy(packet,6,8),ord(copy(packet,14,1)[1])); //TProcess.Create fgt sowohl cidLoginAck als auch das erste Begrungspaket zur Queue des TI hinzu
          MainLog(Format('TI Nr. %d angemeldet; Name "%s"; Typ: %s',[length(TIT),TIT[high(TIT)].GetUserName,TITypeAsString[TIT[high(TIT)].mytitype]]),false);
        end;
      end;
    end;

    if DrawResentFor<=high(TIT) then begin
      //resent zeichnen
      inc(resentposx);
      if resentposx>ImageResent.Width then begin
        ClearImage(ImageResent);
        resentposx:=0;
      end;
      ImageResent.Canvas.Pen.Color:=$000000;
      ImageResent.Canvas.MoveTo(resentposx,ImageResent.Height);
      ImageResent.Canvas.LineTo(resentposx,ImageResent.Height-1-TIT[DrawResentFor].resent*5);
      ImageResent.Canvas.Pen.Color:=$e0e0e0;
      ImageResent.Canvas.LineTo(resentposx,ImageResent.Height-1-TIT[DrawResentFor].maxresent*5);
    end;

    //Pakete verteilen (Weihnachten)
    for i:=0 to high(TIT) do begin
      lpacket:=TIT[i].GetPacket; //get packet to be sent from ti
      if lpacket.id=cidloginack then
        SendPacket(255,cidloginack,lpacket.mpinfo,lpacket.data)              //send login acks always to addr 255
      else if lpacket.id=cidlogoutack then
        for j:=1 to Form2.TrackCSNumOfLogoutAcks.Position do
          SendPacket(TIT[i].GetAddr,lpacket.id,lpacket.mpinfo,lpacket.data)  //send logout data multiple times
      else
        SendPacket(TIT[i].GetAddr,lpacket.id,lpacket.mpinfo,lpacket.data);
      if TIT[i].UnregisterMeNow then UnregisterMe(i);
    end;
    Delay(PauseAfterSendLongPacket);

    //Pakete empfangen
    if length(TIT)>0 then begin
      whois2send :=firstaddr;
      sendSF     :=true;
      //Pakete empfangen (Schleife)
      while whois2send<=lastaddr do begin //whois2send in [firstaddr..lastaddr]
        if sendSF then begin
          if TXEN=TXreceive then
            TXENSend;
          SendPacket(whois2send,4,1,''); //Sendefreigabe an TI
          //TXEN
          TXENReceive;
          sendSF:=false;
        end;
        ReceivePacket(PauseRecv); //50 msec reichen nur fr ca. 100 Byte !!! (bei lngeren Paketen gibt es also noch einen Timeout in dieser Lsung, aber das lt sich ja spter noch korrigieren)
        //Paket akzeptieren?
        if length(packet)<6 then
          packetrcvd:=false
        else
          if ord(packet[paSender])<>whois2send
            then packetrcvd:=false; //Paket ist vom falschen Sender
        if packetrcvd then begin
          {$IFDEF TiSim}
          if ord(packet[paSender])<>FormTiSim.myaddr then begin
            if Form2.CheckCSSendPacketInitString.Checked then
              FormTiSim.ReceiveFromServer(packetinitstr+packet)
            else
            FormTiSim.ReceiveFromServer(packet);
          end;
          {$ENDIF}
          //Paket bearbeiten
          if addr2TI[whois2send]<=high(TIT) then begin
            TIT[addr2TI[whois2send]].ProcessPacket(packet);
            TIT[addr2TI[whois2send]].noreplycount:=0;
          end;
        end else begin
          if Form2.CheckCSKickNotReplyingTIs.Checked then begin
            //was machen wir mit dem Nicht-Antworter?
            inc(TIT[addr2TI[whois2send]].noreplycount);
            if TIT[addr2TI[whois2send]].noreplycount > KickTIAfterUnreplied then begin
              MainLog('Kicke TI '+inttostr(whois2send+1)+' ('+TIT[addr2TI[whois2send]].GetUserName+')',false);
              UnregisterMe(addr2TI[whois2send]);
            end;
          end;
          //Sendefreigabe an nchsten TI
          sendSF:=true;
        end;
        inc(whois2send);
        if (not addrgiven[whois2send]) then begin //Lcke in der Adreliste?
          while (not addrgiven[whois2send]) and (whois2send<=lastaddr) do
            inc(whois2send);
          sendSF:=true; //Sendefreigabe erneut senden
        end; //of if
      end; //of while
    end; //of if
  end; //uerstes while

  HRTimer.Enabled:=false;
  Com.Close;
  if loglevel>=lllow then Log('Port geschlossen');
  CloseFile(logfile);
end;
//
//                     H I G H   L E V E L   L O O P
//
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//
//                 S E N D I N G   A N D   R E C E I V I N G
//
procedure TForm1.SendPacket(an:byte; id:byte; mpinfo:byte; daten:string);
//sendet Daten als Paket (Intermediate Level Protocol) an einen TI
var
  packet   : string; //used to build the packet
  check    : byte;
  i        : integer;
  senddata : string; //copy of packet with leading PacketInitString
begin
  packet:=chr(an) + chr(length(daten)+6) + chr(id) + chr(ServerAddress) + chr(mpinfo) + daten;
  check:=0;
  for i:=1 to length(packet) do
    DoCRC8(check,ord(packet[i]));
  packet:=packet+chr(check);
  if loglevel>=llhigh then LogE('SEND : '+packet);
  if Form2.CheckCSSendPacketInitString.Checked then //Initstring vor jedem Paket (markiert Paketanfang)
    senddata:=Form2.EditCSPacketInitString.Text+packet
  else
    senddata:=packet;
  stillsending:=true;         //damit uns nicht von TXENReceive das Wort abgeschnitten wird
  Com.WriteText(senddata);
  if Form2.RBCSTXENTXEmpty.Checked then
    while stillsending do begin //wait until TXempty
      Application.ProcessMessages;
      if Application.terminated then exit;
    end
  else //wait for calculated time (for sending x bytes @ 19.2kBit/s)
    Delay(round(length(senddata)/1.8));
  {$IFNDEF LogInitStrings} //log InitStrings only if desired
  if loglevel>=llnormal then LogE('SENT : '+packet);
  {$ENDIF}
  {$IFDEF LogInitStrings}
  if loglevel>=llnormal then LogE('SENT : '+senddata);
  {$ENDIF}
  {$IFDEF TiSim}
    FormTiSim.ReceiveFromServer(senddata);
  {$ENDIF}
end;


procedure TForm1.TXENSend;
//setzt TXEN auf Senden
//OnRxChar wird solange TXEN gesetzt bleibt auf nil gesetzt
begin
  if loglevel>=llhigh then Log('TXEN send');
  Com.SetDTRState(true xor Form2.RBCSDTRhighlow.Checked);
  TXEN:=TXsend;
  if Form2.CheckCSMarkingCond.Checked then
    Com.SetBreakState(true);
  Com.OnRxChar := nil;
  Delay(PauseTXEN2w);
  if Form2.CheckCSMarkingCond.Checked then
    Com.SetBreakState(false);
  if Form2.CheckCFSendAfterTXEN.Checked then {$IFDEF LogInitStrings}begin{$ENDIF}
    Com.WriteText(Form2.EditCFSendAfterTXEN.Text);
    {$IFDEF LogInitStrings}
    Log('SENT : '+Form2.EditCFSendAfterTXEN.Text);
  end;
  {$ENDIF}
end;


procedure TForm1.TXENReceive;
//setzt TXEN auf Empfangen
//OnRxChar wird wieder auf Form1.ComRxChar gesetzt, nachdem der Empfangsbuffer der Com-Komponente gelscht wurde
var
  a : string;
begin
  if loglevel>=llhigh then Log('TXEN receive');
  Com.SetDTRState(false xor Form2.RBCSDTRhighlow.Checked);
  TXEN:=TXreceive;
  Delay(PauseTXEN2r);
  if Form2.CheckCSDropRcvdWhileTXENWechsel.Checked then begin
    a:=Com.ReadText;
    if loglevel>=llhigh then Log('DROP : TXEN-Wechsel:'+a);
  end;
  Com.OnRxChar      := Form1.ComRxChar;
  rcvbuffer         := '';
  PacketInitStrRcvd := false;
end;


procedure TForm1.FinishedSending(Sender: TObject);
//alles gesendet -> TXEN darf gelscht werden
//setzt ein Flag, das in SendPacket verwendet wird
begin
  stillsending:=false;
end;


procedure TForm1.ComRxChar(Sender: TObject; Count: Integer);
//liest empfangene Zeichen aus dem Empfangspuffer aus
begin
  rcvbuffer:=rcvbuffer+Com.ReadText;
  ProcessRcvBuffer;
end;
//
//                 S E N D I N G   A N D   R E C E I V I N G
//
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//
//           P R O C E S S I N G   O F   R E C E I V E D   D A T A
//
procedure TForm1.ProcessRcvBuffer;
//bearbeitet den receive buffer (guckt nach InitString und gibt falls gefunden Daten an CheckForPacket weiter)
begin
  if (Form2.CheckCSSendPacketInitString.Checked) and not(PacketInitStrRcvd) then begin
    //delete all chars received before packet start char
    if loglevel>=llhigh then Log('NOTE : Delete all before '+packetinitstr);
    if pos(packetinitstr,rcvbuffer)=0 then begin
      if loglevel>=llhigh then Log('NOTE : emptying rcvbuffer ('+inttostr(length(rcvbuffer))+' Byte:'+EncodeText(rcvbuffer)+')');
      rcvbuffer:=''
    end else begin
      SwitchedTXEN2Receive:=false;
      if loglevel>=llhigh then Log('NOTE : deleting from rcvbuffer ('+inttostr(pos(packetinitstr,rcvbuffer)+length(packetinitstr)-1)+':'+EncodeText(rcvbuffer)+')');
      Delete(rcvbuffer,1,pos(packetinitstr,rcvbuffer)+length(packetinitstr)-1);
      PacketInitStrRcvd:=true;
    end;
  end;
  {$IFDEF LongerBreakWhenReceived}
  HRTimer.Enabled:=false;
  HRTimer.Enabled:=true;
  {$ENDIF}
  if length(rcvbuffer)>=6 then CheckForPacket;
end;


procedure TForm1.CheckForPacket;
//berprft, ob ein vollstndiges Paket im Puffer ist
var
  check  : byte;
  i      : integer;
  lpacket:string;
begin
  if ord(rcvbuffer[2])<6 then begin //ungltige Lnge
    if loglevel>=lllow then Log('DROP : ungltiges Lngenbyte ('+inttostr(length(rcvbuffer))+':'+EncodeText(rcvbuffer)+')');
    PacketInitStrRcvd:=false; //hierdurch wird der Anfang des Buffers bis zum nchsten PacketInitStr verworfen
    ProcessRcvBuffer;
    exit;
  end;
  if length(rcvbuffer)<ord(rcvbuffer[2]) then exit; //noch nicht alles empfangen
  //ja, Paket ist vollstndig
  PacketInitStrRcvd:=false;
  lpacket:=copy(rcvbuffer,1,ord(rcvbuffer[2]));      //Paket zur Weiterverarbeitung kopieren und aus Puffer lschen
  delete(rcvbuffer,1,ord(rcvbuffer[2]));
  if (ord(lpacket[1])<>1) then begin //nicht an Adr. 1?
    if loglevel>=lllow then Log('DROP : nicht fr Server ('+inttostr(length(lpacket))+':'+EncodeTExt(lpacket)+')');
    exit;
  end;
  {if (ord(lpacket[3])=6) then begin //AnmeldeFreigabe?
    if loglevel>=lllow then Log('DROP : Anmeldefreigabe ('+inttostr(length(lpacket))+':'+EncodeText(lpacket)+')');
    exit;
  end;}
  //ja, Empfnger ist Server
  check:=0;
  for i:=1 to length(lpacket)-1 do
    DoCRC8(check,ord(lpacket[i]));
  if check<>ord(lpacket[length(lpacket)]) then begin
    if loglevel>=lllow then Log('DROP : Prfsummenfehler');
    exit;
  end;
  //ja, Prfsumme ist ok
  if loglevel>=llnormal then LogE('RCVD : '+lpacket);
  packet:=lpacket;
  packetrcvd:=true;
end;
//
//           P R O C E S S I N G   O F   R E C E I V E D   D A T A
//
////////////////////////////////////////////////////////////////////////////////


procedure TForm1.KickUser(index:integer);
//kick the ti with the index
begin
  TIT[index].Send2TIContentFile('kickme');
end;


procedure TForm1.UnregisterMe(index:integer);
//unregister the ti with the index
var
  i    : integer;
  addr : integer;
begin
  if index>high(TIT) then begin
    MainLog(inttostr(index)+' kann nicht mehr abgemeldet werden.',true);
    exit;
  end;
  //read out data
  MainLog('TI Nr. '+inttostr(index+1)+' abgemeldet, Name:'+TIT[index].GetUserName,true);
  addr:=TIT[index].GetAddr;
  userdata[TIT[index].userdatai].online:=false;
  //delete TIT[index]
  TIT[index].Free;
  for i:=index to high(TIT)-1 do
    TIT[i]:=TIT[i+1];
  SetLength(TIT,length(TIT)-1);
  //set-up addresses
  addrgiven[addr]:=false;
  addr2TI  [addr]:=0;
  if firstaddr=addr then begin //find new lowest addr
    firstaddr:=255;
    for i:=0 to high(TIT) do
      if TIT[i].myaddr<firstaddr then firstaddr:=TIT[i].myaddr;
    MainLog('Neue niedrigste Adresse:'+inttostr(firstaddr),true);
  end else
    if lastaddr=addr then begin //find new highest addr
      lastaddr:=0;
      for i:=0 to high(TIT) do
        if TIT[i].myaddr>lastaddr then lastaddr:=TIT[i].myaddr;
      MainLog('Neue hchste Adresse:'+inttostr(lastaddr),true);
    end;
  EditNumOfTIs.Text:=inttostr(length(TIT));
end;


procedure TForm1.MainLog(text:string;tofile:boolean);
//zeigt den text im MemoMainEventLog an und speichert falls tofile=true auch in logfile
begin
  MemoMainEventLog.Lines.Add(text);
  if tofile then Log(text);
end;


procedure TForm1.Log(text:string);
//speichert text in die Logdatei
begin
  try
    Writeln(logfile,inttostr(GetTickCount)+':'+text);
  except
    ShowMessage('Fehler beim Schreiben in Log');
  end;
end;


procedure TForm1.LogE(text:string);
//speichert text mit umschriebenen ASC-Codes in die Logdatei
begin
  Log(EncodeText(text));
end;


procedure TForm1.DoCRC8(var crc8:byte;x:byte);
// CRC8 Berechnung
//  This procedure calculates the cumulative Dallas Semiconductor one-wire CRC8 of all bytes passed to it.  The result accumulates in the global variable CRC8.
const
   Table : Array[0..255] of Byte = (
        0, 94,188,226, 97, 63,221,131,194,156,126, 32,163,253, 31, 65,
      157,195, 33,127,252,162, 64, 30, 95,  1,227,189, 62, 96,130,220,
       35,125,159,193, 66, 28,254,160,225,191, 93,  3,128,222, 60, 98,
      190,224,  2, 92,223,129, 99, 61,124, 34,192,158, 29, 67,161,255,
       70, 24,250,164, 39,121,155,197,132,218, 56,102,229,187, 89,  7,
      219,133,103, 57,186,228,  6, 88, 25, 71,165,251,120, 38,196,154,
      101, 59,217,135,  4, 90,184,230,167,249, 27, 69,198,152,122, 36,
      248,166, 68, 26,153,199, 37,123, 58,100,134,216, 91,  5,231,185,
      140,210, 48,110,237,179, 81, 15, 78, 16,242,172, 47,113,147,205,
       17, 79,173,243,112, 46,204,146,211,141,111, 49,178,236, 14, 80,
      175,241, 19, 77,206,144,114, 44,109, 51,209,143, 12, 82,176,238,
       50,108,142,208, 83, 13,239,177,240,174, 76, 18,145,207, 45,115,
      202,148,118, 40,171,245, 23, 73,  8, 86,180,234,105, 55,213,139,
       87,  9,235,181, 54,104,138,212,149,203, 41,119,244,170, 72, 22,
      233,183, 85, 11,136,214, 52,106, 43,117,151,201, 74, 20,246,168,
      116, 42,200,150, 21, 75,169,247,182,232, 10, 84,215,137,107, 53);
begin
  crc8 := Table[crc8 xor X];
end;


function TForm1.GetFreeAddr(forwhom:byte):byte;
//returns the next available address for an TI (this is the only part where Unit1 has to care about addresses)
var
  i:integer;
begin
  result:=0;
  for i:=1 to 255 do
    if addrgiven[i]=false then begin
      addrgiven[i]:=true;
      addr2TI[i]:=forwhom;
      if firstaddr>i then firstaddr:=i;
      if i>lastaddr  then lastaddr:=i;
      result:=i;
      break;
    end;
  if result=0 then ShowMessage('Kritischer Fehler: keine freie Adresse fr neuen TI, 0 vergeben!');
end;


/////////////////////   \/  E V E N T H A N D L E R  \/  ///////////////////////


procedure TForm1.MenuExitClick(Sender: TObject);
begin
  Self.Close;
end;


procedure TForm1.MMShowClick(Sender: TObject);
begin
  {$IFDEF TISim}
    FormTiSim.Show;
  {$ENDIF}
end;


procedure TForm1.MMHideClick(Sender: TObject);
begin
  {$IFDEF TISim}
    FormTiSim.Hide;
  {$ENDIF}
end;


procedure TForm1.MMConfigClick(Sender: TObject);
//show form2
begin
  Form2.ShowModal;
end;


procedure TForm1.FormCreate(Sender: TObject);
//load users file
var
  myfile : textfile;
  a      : string;
  i,j    : integer;
begin
  if not FileExists('users.txt') then begin
    MainLog('"users.txt" not found.',false);
    exit;
  end;
  try
    AssignFile(myfile,'users.txt');
    ReSet(myfile);
    ReadLn(myfile,a); //dummy
    ReadLn(myfile,a); //number of users
    SetLength(userdata,strtoint(copy(a,pos('=',a)+1,10)));
    ReadLn(myfile,a); //total uptime
    totaluptime:=strtoint(a);
    for i:=1 to length(userdata) do
      with userdata[i-1] do begin
        ReadLn(myfile,uname);
        uname:=uppercase(uname);
        uname:=copy(uppercase(uname),pos('=',uname)+1,255);
        ReadLn(myfile,upass);
        upass:=copy(upass,pos('=',upass)+1,255);
        admin:=ReadLnBoolean(myfile);
        //mail account info
        ReadLn(myfile,pop3host);
        ReadLn(myfile,pop3user);
        ReadLn(myfile,pop3pass);
        ReadLn(myfile,smtphost);
        ReadLn(myfile,smtpuser);
        ReadLn(myfile,smtppass);
        ReadLn(myfile,smtpaddr);
        ReadLn(myfile,smtpname);
        //messages
        ReadLn(myfile,a);
        SetLength(messages,strtoint(a));
        for j:=1 to strtoint(a) do
        with messages[j-1] do begin
          ReadLn(myfile,from);
          ReadLn(myfile,msg);
          ReadLn(myfile,time);
          read:=ReadLnBoolean(myfile);
        end;
      end;
    CloseFile(myfile);
  except
    ShowMessage('Exception on loading user data');
    halt;
  end;
  if FileExists(FeedbackRessourceFile) then
  try
    AssignFile(myfile,FeedbackRessourceFile);
    ReSet(myfile);
    SetLength(feedback,0);
    while not eof(myfile) do begin
      SetLength(feedback,length(feedback)+1);
      with feedback[high(feedback)] do begin
        ReadLn(myfile,from);
        ReadLn(myfile,msg);
        ReadLn(myfile,time);
      end;
    end;
    CloseFile(myfile);
  except
    on E:exception do begin
      ShowMessage('Exception on loading feedback'+e.message);
      halt;
    end;
  end;
  {$IFDEF TiSim}
    MainMenu.Items[2].Visible:=true;
  {$ENDIF}
  Randomize;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
//save users file
var
  myfile : textfile;
  i,j    : integer;
begin
  RunServer:=False;
  wait:=false;
  try
    AssignFile(myfile,'users.txt');
    ReWrite(myfile);
    WriteLn(myfile,'Die Zeilenanzahl und -struktur in dieser Datei darf nicht verndert werden!');
    WriteLn(myfile,'Anzahl der Eintrge='+inttostr(length(userdata))); //number of users
    WriteLn(myfile,inttostr(totaluptime));
    for i:=0 to high(userdata) do
      with userdata[i] do begin
        WriteLn(myfile,'Username='+uname);
        WriteLn(myfile,'Passwort='+upass);
        WriteLnBoolean(myfile,admin);
        //mail account info
        WriteLn(myfile,pop3host);
        WriteLn(myfile,pop3user);
        WriteLn(myfile,pop3pass);
        WriteLn(myfile,smtphost);
        WriteLn(myfile,smtpuser);
        WriteLn(myfile,smtppass);
        WriteLn(myfile,smtpaddr);
        WriteLn(myfile,smtpname);
        //messages
        WriteLn(myfile,length(messages));
        for j:=0 to high(messages) do
          with messages[j] do begin
            WriteLn(myfile,from);
            WriteLn(myfile,msg);
            WriteLn(myfile,time);
            WriteLnBoolean(myfile,admin);
          end;
      end;
    CloseFile(myfile);
  except
    ShowMessage('Exception on writing user data');
  end;
  try
    AssignFile(myfile,FeedbackRessourceFile);
    ReWrite(myfile);
    for i:=0 to high(feedback) do
      with feedback[i] do begin
        WriteLn(myfile,from);
        WriteLn(myfile,msg);
        WriteLn(myfile,time);
      end;
    CloseFile(myfile);
  except
    on E:exception do begin
      ShowMessage('Exception on writing feedback'+e.message);
      halt;
    end;
  end;
end;


procedure TForm1.TimerUptimeTimer(Sender: TObject);
//count up-time
begin
  inc(uptime);
  inc(totaluptime);
  EditUpTime.Text            :=format('%2.2d:%2.2d',[uptime div 60,uptime mod 60]);
end;

procedure TForm1.TrackChange(Sender: TObject);
//change loglevel
begin
  case Track.Position of
    1:loglevel:=llno;
    2:loglevel:=lllow;
    3:loglevel:=llnormal;
    4:loglevel:=llhigh;
    5:loglevel:=llhighest;
  end;
end;


procedure TForm1.AppEventsException(Sender: TObject; E: Exception);
//catch unhandled exceptions
begin
  ShowMessage('Ausnahmefehler abgefangen:'#13#10+E.Message);
end;


///////////////////   \/  M I S C E L L A N E O U S  \/  ///////////////////////


procedure TForm1.ClearImage(Image:TImage);
//fills the image with solid white
begin
  with Image do begin
    Canvas.Brush.Color:=$ffffff;
    Canvas.FillRect(Rect(0,0,Width,Height));
    Canvas.MoveTo(0,Canvas.PenPos.y);
    Canvas.Brush.Color:=$000000;
  end;
end;


procedure TForm1.UpDownStatusClick(Sender: TObject; Button: TUDBtnType);
//change inscription of Image (LabelImageMax.Caption)
begin
  LabelImageMax.Caption:=inttostr(ImageStatus.Height*UpDownStatus.Position);
  //ImageStatus.Canvas.MoveTo(0,0);
  //ClearImage(ImageStatus);
end;


procedure TForm1.MMServerVersionClick(Sender: TObject);
//show server version
begin
  ShowMessage('TI-Net Server v3'#13#10#13#10'Exename: '+Application.ExeName+#13#10+
              'Version: '+version+#13#10+
              'compiliert am: '+FormatDateTime('yyyy.mm.dd "um" hh:nn',FileDateToDateTime(FileAge(Application.ExeName))));
end;


function TForm1.ReadLnBoolean(var myfile:textfile):boolean;
//read line from file and return true if line='true'
var
  a : string;
begin
  ReadLn(myfile,a);
  if a='true' then
    result:=true
  else
    result:=false;
end;

procedure TForm1.WriteLnBoolean(var myfile:textfile;a:boolean);
//write line to file with boolean value of a
begin
  if a then
    WriteLn(myfile,'true')
  else
    WriteLn(myfile,'false');
end;

function TForm1.AlreadyRegistered(name:string):boolean;
//checks if user with name is already online
var
  a     : string;
  i     : integer;
begin
  a:=copy(packet,6,8)+#0;
  a:=uppercase(copy(a,1,pos(#0,a)-1));
  result:=false;
  for i:=0 to high(TIT) do
    if uppercase(TIT[i].myuser)=a then begin
      result:=true;
      break;
    end;
end;

end.

