//modified:2003.01.16@22:44 by Alex
//Project: TI-Server v3

unit UnitConfig;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, UnitMy, ExtCtrls, Math;

type
  TForm2 = class(TForm)
    PageConfig: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox2: TGroupBox;
    RBCSTXENBreak: TRadioButton;
    RBCSTXENTXEmpty: TRadioButton;
    GroupBox3: TGroupBox;
    RBCSDTRhighlow: TRadioButton;
    RBCSDTRhighhigh: TRadioButton;
    GroupBox4: TGroupBox;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label6: TLabel;
    EditCSTXEN2r: TEdit;
    EditCSTXEN2w: TEdit;
    EditCSRegisterWait: TEdit;
    EditCSReceiveWait: TEdit;
    CheckCSMarkingCond: TCheckBox;
    EditCSPacketInitString: TEdit;
    GroupBox5: TGroupBox;
    Label10: TLabel;
    EditCIProxyIP: TEdit;
    Label11: TLabel;
    EditCIProxyPort: TEdit;
    CheckCSSendPacketInitString: TCheckBox;
    Label9: TLabel;
    EditCSPauseAfterSendShortPacket: TEdit;
    TabSheet3: TTabSheet;
    Label1: TLabel;
    EditCSContent: TEdit;
    CheckCSNoWrap: TCheckBox;
    GroupBox6: TGroupBox;
    CheckCSDeleteOldLog: TCheckBox;
    Label13: TLabel;
    EditCSMaxLogLines: TEdit;
    Label12: TLabel;
    Label14: TLabel;
    LabelDeleteLog: TLabel;
    CheckDoNotUseTableInTiSim: TCheckBox;
    Label15: TLabel;
    EditCSMaxLenSinglePacket: TEdit;
    CheckCFSendAfterTXEN: TCheckBox;
    EditCFSendAfterTXEN: TEdit;
    CheckCSKickNotReplyingTIs: TCheckBox;
    EditCSKickAfterNumOfNoReplies: TEdit;
    Label16: TLabel;
    ComboCSPort: TComboBox;
    CheckCSLoginCompulsory: TCheckBox;
    CheckCSLimitNumOfMails: TCheckBox;
    EditCSMaxNumOfMails: TEdit;
    CheckCSLimitSizeOfMails: TCheckBox;
    EditCSMaxSizeOfMails: TEdit;
    EditCSPauseAfterSendLongPacket: TEdit;
    CheckCSDropRcvdWhileTXENWechsel: TCheckBox;
    TrackCSNumOfLogoutAcks: TTrackBar;
    LabelNumOfLogOutAcks: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure SetUpVars;
    procedure LabelDeleteLogClick(Sender: TObject);
    procedure AllowOnlyFigures(Sender: TObject; var Key: Char);
    procedure CheckCSKickNotReplyingTIsClick(Sender: TObject);
    procedure CheckCSLimitNumOfMailsClick(Sender: TObject);
    procedure CheckCSLimitSizeOfMailsClick(Sender: TObject);
    procedure TrackCSNumOfLogoutAcksChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form2   : TForm2;
  started : boolean;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm2.FormShow(Sender: TObject);
//Einstellungen laden
var
  MyRegistry : TMyRegistry;
  i          : integer;
begin
  if started then exit;
  MyRegistry:=TMyRegistry.Create;
  //read available com ports
  MyRegistry.RootKey:=HKEY_LOCAL_MACHINE;
  MyRegistry.OpenKey('hardware\devicemap\serialcomm',false);
  MyRegistry.GetValueNames(ComboCSPort.Items);
  for i := 0 to ComboCSPort.Items.Count-1 do begin
    ComboCSPort.Items.Strings[i] := MyRegistry.ReadString(ComboCSPort.Items.Strings[i]);
  end;
  MyRegistry.CloseKey;
  // read registry info
  MyRegistry.RootKey:=HKEY_CURRENT_USER;
  MyRegistry.OpenKey('Software\85\TI-Server\',true);
  with Form2 do
    for i:=0 to ComponentCount-1 do begin
      if (Components[i] is TEdit) then
        (Components[i] as TEdit).text:=MyRegistry.ReadStringD(Components[i].Name,(Components[i] as TEdit).text)
      else if (Components[i] is TRadioButton) then
        (Components[i] as TRadioButton).Checked:=MyRegistry.ReadBoolean(Components[i].Name,(Components[i] as TRadioButton).Checked)
      else if (Components[i] is TListBox) then
        (Components[i] as TListBox).ItemIndex:=MyRegistry.ReadIntegerD(Components[i].Name,(Components[i] as TListBox).ItemIndex)
      else if (Components[i] is TCheckBox) then
        (Components[i] as TCheckBox).Checked:=MyRegistry.ReadBoolean(Components[i].Name,(Components[i] as TCheckBox).Checked)
      else if (Components[i] is TComboBox) then
        (Components[i] as TComboBox).ItemIndex:=min(MyRegistry.ReadIntegerD(Components[i].Name,(Components[i] as TComboBox).ItemIndex),ComboCSPort.Items.Count-1)
      else if (Components[i] is TTrackBar) then
        (Components[i] as TTrackBar).Position:=MyRegistry.ReadIntegerD(Components[i].Name,(Components[i] as TTrackBar).Position);
    end;
  SetUpVars;
  started:=true;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
//Einstellungen speichern
var
  MyRegistry : TMyRegistry;
  i          : integer;
begin
  MyRegistry:=TMyRegistry.Create;
  MyRegistry.RootKey:=HKEY_CURRENT_USER;
  MyRegistry.OpenKey('Software\85\TI-Server\',true);
  with Form2 do
    for i:=0 to ComponentCount-1 do begin
      if (Components[i] is TEdit) then
        MyRegistry.WriteString(Components[i].Name,(Components[i] as TEdit).text)
      else if (Components[i] is TRadioButton) then
        MyRegistry.WriteBoolean(Components[i].Name,(Components[i] as TRadioButton).Checked)
      else if (Components[i] is TListBox) then
        MyRegistry.WriteInteger(Components[i].Name,(Components[i] as TListBox).ItemIndex)
      else if (Components[i] is TCheckBox) then
        MyRegistry.WriteBoolean(Components[i].Name,(Components[i] as TCheckBox).Checked)
      else if (Components[i] is TComboBox) then
        MyRegistry.WriteInteger(Components[i].Name,(Components[i] as TComboBox).ItemIndex)
      else if (Components[i] is TTrackBar) then
        MyRegistry.WriteInteger(Components[i].Name,(Components[i] as TTrackBar).Position);
    end;
  SetUpVars;
  MyRegistry.Free;
end;

procedure TForm2.SetUpVars;
//pass values of preferences to vars in Form1
var
  i : integer;
begin
  val(EditCSTXEN2r.Text,Form1.PauseTXEN2r,i);
  val(EditCSTXEN2w.Text,Form1.PauseTXEN2w,i);
  val(EditCSRegisterWait.Text,Form1.PauseRegis,i);
  val(EditCSReceiveWait.Text,Form1.PauseRecv,i);
  val(EditCSPauseAfterSendShortPacket.Text,Form1.PauseAfterSendShortPacket,i);
  val(EditCSPauseAfterSendLongPacket.Text,Form1.PauseAfterSendLongPacket,i);
  val(EditCSMaxLogLines.Text,Form1.MaxLogLines,i);
  if Form1.MaxLogLines<2000 then begin
    EditCSMaxLogLines.Text:='2000';
    Form1.MaxLogLines:=2000;
  end;
  val(EditCSMaxLenSinglePacket.Text,Form1.MaxPacketLen,i);
  if Form1.MaxPacketLen<1 then begin
    EditCSMaxLenSinglePacket.Text:='1';
    Form1.MaxPacketLen:=1;
  end else
    if Form1.MaxPacketLen>249 then begin
      EditCSMaxLenSinglePacket.Text:='249';
      Form1.MaxPacketLen:=249;
    end;
  val(EditCSKickAfterNumOfNoReplies.Text,Form1.KickTIAfterUnreplied,i);
  if Form1.KickTIAfterUnreplied=0 then
    CheckCSKickNotReplyingTIs.Checked:=false;
  Form1.packetinitstr:=EditCSPacketInitString.Text;
  val(copy(ComboCSPort.Text,4,1),i,i);
  Form1.Com.PortNum:=i;
  val(EditCSMaxNumOfMails.Text,Form1.MaxNumofMails,i);
  val(EditCSMaxSizeOfMails.Text,Form1.MaxSizeofMails,i);
end;

procedure TForm2.LabelDeleteLogClick(Sender: TObject);
var
  i : integer;
  sr: TSearchRec;
begin
  if Form1.RunServer then begin
    ShowMessage('Geht nicht solange der Server luft.');
    exit;
  end;
  if MessageDlg('Logdateien wirklich lschen?',mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;
  i:=0;
  if FindFirst('./tiserverlog????????@??????.txt', 0, sr) = 0 then begin
    inc(i);
    DeleteFile(sr.Name);
    while FindNext(sr) = 0 do begin
      inc(i);
      DeleteFile(sr.Name);
    end;
    FindClose(sr);
  end;
  if FileExists('./tiserverlog.txt') then begin
    inc(i);
    DeleteFile('./tiserverlog.txt');
  end;
  if i<>1 then
    ShowMessage(inttostr(i)+' Logdateien gelscht.')
  else
    ShowMessage('Eine Logdatei gelscht.')
end;

procedure TForm2.AllowOnlyFigures(Sender: TObject;  var Key: Char);
begin
  if not(key in ['0'..'9',#8]) then key:=#0;
end;

procedure TForm2.CheckCSKickNotReplyingTIsClick(Sender: TObject);
begin
  EditCSKickAfterNumOfNoReplies.Enabled:=CheckCSKickNotReplyingTIs.Checked;
end;

procedure TForm2.CheckCSLimitNumOfMailsClick(Sender: TObject);
begin
  EditCSMaxNumOfMails.Enabled:=CheckCSLimitNumOfMails.Checked;
end;

procedure TForm2.CheckCSLimitSizeOfMailsClick(Sender: TObject);
begin
  EditCSMaxSizeOfMails.Enabled:=CheckCSLimitSizeOfMails.Checked;
end;

procedure TForm2.TrackCSNumOfLogoutAcksChange(Sender: TObject);
//update label
begin
  LabelNumOfLogOutAcks.Caption:='Logout ACK wird '+inttostr(TrackCSNumOfLogoutAcks.Position)+' Mal gesendet'
end;

end.
