//modified:2002.07.16@19:40 by Alex
//Project: TI-Server v3

//simulates a ti interacting with ti-net-server

unit UnitTiSim;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WSocket, WSocketS, StdCtrls, Menus, UnitTypes, ExtCtrls;

type
  TFormTiSim = class(TForm)
    MemoTIScr: TMemo;
    MemoLog: TMemo;
    Label1: TLabel;
    EditUsername: TEdit;
    Label2: TLabel;
    EditAddress: TEdit;
    CmdConnect: TButton;
    EditInput: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    EditEditField: TEdit;
    Label5: TLabel;
    CmdSilentDisconnect: TButton;
    RGTIType: TRadioGroup;
    function  DescribeASC(text:String):string;
    procedure Log(text:string);
    procedure ProcessReceived(data:string);
    procedure DoCRC8(var crc8:byte;x:byte);
    procedure EditUsernameChange(Sender: TObject);
    procedure TiCls;
    procedure TiPrint(text:string);
    procedure TiPrintDirect(text:string);
    procedure TiLocate(x:byte;y:byte);
    procedure CmdConnectClick(Sender: TObject);
    procedure ReceiveFromServer(data:string);
    function  SendToServer:string;
    procedure FormShow(Sender: TObject);
    procedure EditInputKeyPress(Sender: TObject; var Key: Char);
    procedure EditEditFieldKeyPress(Sender: TObject; var Key: Char);
    procedure CmdSilentDisconnectClick(Sender: TObject);
    procedure EditUsernameKeyPress(Sender: TObject; var Key: Char);
    procedure RGTITypeClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    myaddr        : integer;
    mytitype      : TTIType;
  end;

  TQueuedPacket = record
    id    : integer;
    daten : string;
  end;

var
  FormTiSim     : TFormTiSim;
  rcvbuffer     : string;
  myusername    : string;  //my username
  registernow   : boolean; //shall I register the next time I get an Anmeldefreigabe?
  replynow      : boolean; //have I SendeFreigabe?
  replycid      : integer; //the content id to use when sending next packet
  TiScrX,TiScrY : integer;
  QueuedPacket  : TQueuedPacket;  //packet to send
  mpbuffer      : string;  //buffer used when receiving multi packets to temp.ly store received data
  mpnop         : integer; //number of packets in current multi packet


implementation

uses Unit1, UnitConfig;

{$R *.DFM}


function TFormTiSim.DescribeASC(text:String):string;
//replace #0..#32,#127..#255 by '#0'..'#32','#127'..'#255'
var
  i : integer;
begin
  for i:=1 to length(text) do
    if (text[i]<#32) or (text[i]>#127) then
      result:=result+'<'+inttostr(ord(text[i]))+'>'
    else
      result:=result+text[i];
end;


procedure TFormTiSim.Log(text:string);
//log text
begin
  MemoLog.Lines.Add(text);
end;


procedure TFormTiSim.ReceiveFromServer(data:string);
//receive data from server
begin
  ProcessReceived(data);
end;


function  TFormTiSim.SendToServer:string;
//send data to server, doesn't support multi packet yet!
var
  packet : string;
  check  : byte;
  i      : integer;
begin
  result:='';
  if not replynow then exit; //it's not my turn
  replynow:=false;
  with QueuedPacket do begin
    packet:=#1 + chr(length(daten)+6) + chr(id) + chr(myaddr) + #1 + daten;
    check :=0;
    for i:=1 to length(packet) do
      DoCRC8(check,ord(packet[i]));
    id    :=10; //send empty packet from now on
    daten :='';
    if Form2.CheckCSSendPacketInitString.Checked then
      packet:=Form1.packetinitstr+packet;
    result:=packet+chr(check);
  end;
end;


procedure TFormTiSim.ProcessReceived(data:string);
//process received data (var rcvbuffer)
var
  proc,a  : string;
  cid     : integer; //content-id
  packet  : string;
  content : string;
  i,j,k   : integer;
begin
  replynow:=false;
  if (Form2.CheckCSSendPacketInitString.Checked) then
    //delete all chars received before packet start char
    if pos(Form1.packetinitstr,data)=0 then
      exit
    else
      data:=copy(data,pos(Form1.packetinitstr,data)+length(Form1.packetinitstr),length(data));
  //process received data
  if length(data)<ord(data[paLength]) then exit; //too short, shorty!
  proc:=copy(data,1,ord(data[paLength])); //create local copy of rcvbuffer
  cid:=ord(proc[paCid]);
  //process packet
  if (ord(proc[paRcpt])=0) and (cid=cidAnmeldefreigabe) then begin //rcpt=0, id=6
    //Anmeldefreigabe empfangen
    if not registernow then exit; //dann eben nich...
    packet:=myusername;
    while length(packet)<8 do
      packet:=packet+#0; //fill username with #0 up to 8 chars
    replynow:=true;
    QueuedPacket.id:=0;
    QueuedPacket.daten:=packet+chr(TILogInCode[mytitype])+#0#0+#0#0;
    Log('Anmeldungsanforderung wird gesendet.');
    registernow:=false;
    exit;
  end;
  if (ord(proc[paRcpt])=$FF) and (cid=cidloginack) then begin //rcpt=$ff, id=7
    //Anmeldebesttigung
    a:=copy(proc,6,8);
    if pos(#0,a)>0 then a:=copy(a,1,pos(#0,a)-1); //trim #0
    if myusername<>a then begin //not for me
      Log('Anmeldebesttigung an "'+a+'"<> ich:'+myusername);
      exit;
    end;
    myaddr:=ord(proc[14]);
    Log('Anmeldebesttigung empfangen.');
    EditAddress.Text:=inttostr(myaddr);
    CmdConnect.Caption:='Dis&connect';
    exit;
  end;
  if (ord(proc[paRcpt]))=ServerAddress then //if ti before me has sent -> reply now and exit
    if ((ord(proc[paSender]))=myaddr-1) and (myaddr<>255) then begin
      replynow:=true;
      exit;
    end;
  if (ord(proc[paRcpt])<>myaddr) then exit;  //not for me
  if cid=cidemptypacket          then exit;  //empty packet  -> do nothing
  if cid=cidack                  then exit;  //ack           -> do nothing
  if cid=cidsendefreigabe        then begin  //Sendefreigabe -> reply now and exit
    replynow:=true;
    exit;
  end;
  QueuedPacket.id   :=cidack;  //queue ACK
  QueuedPacket.daten:='';
  replynow          :=true;

  //check for multi packet
  if (cid and 128)=128 then begin //cont'd multi packet
    mpbuffer:=mpbuffer+copy(proc,6,ord(proc[paLength])-6);
    if ord(proc[paMultiPacket])<mpnop then exit; //exit if not last packet received
    cid:=cid and 127;
    content:=mpbuffer;
  end else
    if ord(proc[paMultiPacket])>1 then begin //multi packet start
      mpbuffer:=copy(proc,6,ord(proc[paLength])-6);
      mpnop   :=ord(proc[paMultiPacket]);
      exit;
    end else
      content:=copy(proc,6,ord(proc[paLength])-6); //nothing with multi packet

  EditEditField.Enabled:=false;
  case cid of
    cidack :                      //acknowledge
      begin
        QueuedPacket.id:=cidemptypacket;
      end;
    cidlogoutack :                //logout ack
      begin
        myaddr             := $ff;
        replycid           := -1;
        EditAddress.Text   := '$FF';
        CmdConnect.Caption := '&Connect';
        RGTIType.Enabled   := true;
        Log('Abmeldebesttigung empfangen.');
        TiCls;
      end;
    cidplaintext :                //plain text
      begin
        TiCls;
        TiPrint(copy(content,1,length(content)-1));
        replycid:=cidreplyplaintext;
        EditInput.SetFocus;
      end;
    cidfullscreenmenu:            //full screen menu
      begin
        TiCls;
        k:=pos(#0,copy(content,4,TIScrWidthinChars[mytitype]+1));
        if k=0 then begin
          Log('Ungltiger Titel eines Fullscreen-Mens');
          k:=1;
        end else
          TiPrint(copy(content,4,k-1));
        i:=0; //counts number of displayed items
        j:=k+4;
        while j<length(content) do begin
          inc(i);
          TiLocate(0,i);
          k:=pos(#0,copy(content,j,TIScrWidthinChars[mytitype]+1));
          TiPrint(inttostr(i)+' '+copy(content,j,k-1));
          inc(j,k);
        end;
        if i<>ord(content[1]) then
          Log(Format('Ungltige Angabe der Anzahl der Items im Fullscreen-Men (%d statt %d)',[ord(content[1]),i]));
        replycid:=cidreplyfullscreenmenu;
        EditInput.SetFocus;
      end;
    cideditfield:                //edit field
      begin
        TiCls;
        TiLocate(ord(content[2]),ord(content[1]));
        i:=ord(content[3]); //Lnge des Erluterungstextes
        TiPrint(copy(content,4,i));
        TiLocate(ord(content[5+i]),ord(content[4+i]));
        TiPrintDirect(copy('['+StringOfChar('#',ord(content[7+i])-2)+']',1,ord(content[7+i])));
        EditEditField.Enabled:=true;
        EditEditField.MaxLength:=ord(content[8+i]);
        EditEditField.Text:=copy(content,10+i,ord(content[9+i]));
        replycid:=cidreplyeditfield;
        EditEditField.SetFocus;
      end;
    else //unknown id
      Log('Unbekannte ID:'+inttostr(cid)+' in Paket '+DescribeASC(proc));
  end; //of case
end;


procedure TFormTiSim.DoCRC8(var crc8:byte;x:byte);
// CRC8 Berechnung
//  This procedure calculates the cumulative Dallas Semiconductor one-wire CRC8 of all bytes passed to it.  The result accumulates in the global variable CRC8.
const
   Table : Array[0..255] of Byte = (
        0, 94,188,226, 97, 63,221,131,194,156,126, 32,163,253, 31, 65,
      157,195, 33,127,252,162, 64, 30, 95,  1,227,189, 62, 96,130,220,
       35,125,159,193, 66, 28,254,160,225,191, 93,  3,128,222, 60, 98,
      190,224,  2, 92,223,129, 99, 61,124, 34,192,158, 29, 67,161,255,
       70, 24,250,164, 39,121,155,197,132,218, 56,102,229,187, 89,  7,
      219,133,103, 57,186,228,  6, 88, 25, 71,165,251,120, 38,196,154,
      101, 59,217,135,  4, 90,184,230,167,249, 27, 69,198,152,122, 36,
      248,166, 68, 26,153,199, 37,123, 58,100,134,216, 91,  5,231,185,
      140,210, 48,110,237,179, 81, 15, 78, 16,242,172, 47,113,147,205,
       17, 79,173,243,112, 46,204,146,211,141,111, 49,178,236, 14, 80,
      175,241, 19, 77,206,144,114, 44,109, 51,209,143, 12, 82,176,238,
       50,108,142,208, 83, 13,239,177,240,174, 76, 18,145,207, 45,115,
      202,148,118, 40,171,245, 23, 73,  8, 86,180,234,105, 55,213,139,
       87,  9,235,181, 54,104,138,212,149,203, 41,119,244,170, 72, 22,
      233,183, 85, 11,136,214, 52,106, 43,117,151,201, 74, 20,246,168,
      116, 42,200,150, 21, 75,169,247,182,232, 10, 84,215,137,107, 53);
begin
  crc8 := Table[crc8 xor X];
end;


procedure TFormTiSim.EditUsernameChange(Sender: TObject);
begin
  if EditUsername.Text<>'' then myusername:=EditUsername.text;
  EditUsername.Text:=myusername;
end;


procedure TFormTiSim.TiCls;
//clear virtual ti screen
var
  i : integer;
begin
  MemoTiScr.Text:='';
  for i:=0 to 7 do
    MemoTIScr.Text:=MemoTiScr.Text+StringOfChar(' ',TIScrWidthInChars[mytitype])+#13#10;
  TiScrX:=0;
  TiScrY:=0;
end;


procedure TFormTiSim.TiPrintDirect(text:string);
//prints the text without doing the table en-/decoding
//(well, actually it does the encoding twice, i.e. once and then calls TIPrint)
var
  i     : integer;
  table : TByteTable;
begin
  case mytitype of
    TI82 : table := tableASC2TI82;
    TI86 : table := tableASC2TI86;
  end;
  for i:=1 to length(text) do
    if (table[ord(text[i])]<>0) then
      text[i]:=chr(table[ord(text[i])]);
  TiPrint(text);
end;


procedure TFormTiSim.TiPrint(text:string);
//print the text on our virtual ti screen
var
  i     : integer;
  scr   : string;
  table : TByteTable;
begin
  scr:=MemoTIScr.Text;
  case mytitype of
    TI82 : table := tableTI822ASC;
    TI86 : table := tableTI862ASC;
  end;
  for i:=1 to length(text) do begin
    if (table[ord(text[i])]<>0) and not (Form2.CheckDoNotUseTableInTiSim.Checked) then
      scr[TiScrY*(TIScrWidthInChars[mytitype]+2)+TiScrX+1]:=chr(table[ord(text[i])])
    else
      scr[TiScrY*(TIScrWidthInChars[mytitype]+2)+TiScrX+1]:=text[i];
    inc(TiScrX);
    if TiScrX>(TIScrWidthInChars[mytitype]-1) then begin
      TiScrX:=0;
      inc(TiScrY);
      if TiScrY>7 then TiScrY:=0;
    end;
  end;
  MemoTIScr.Text:=scr;
end;


procedure TFormTiSim.TiLocate(x:byte;y:byte);
//locate cursor on screen
begin
  TiScrX:=x;
  TiScrY:=y;
end;


procedure TFormTiSim.CmdConnectClick(Sender: TObject);
//set var registernow
begin
  if CmdConnect.Caption='&Connect' then begin
    registernow     :=true;
    RGTIType.Enabled:=false;
  end else
    with QueuedPacket do begin //logout
      id   :=cidlogoutrequest;
      daten:='';
    end;
end;


procedure TFormTiSim.FormShow(Sender: TObject);
//init form
begin
  myusername:= 'TiSim';
  myaddr    := $FF;
  EditAddress.Text:='$FF';
  replycid  := -1;
  MemoLog.Clear;
  TiCls;
end;


procedure TFormTiSim.EditInputKeyPress(Sender: TObject; var Key: Char);
//send input to server
begin
  key:=uppercase(key)[1];
  if not(key in['0'..'9','O','U','L','R',#27,#13]) then begin
    key:=#0;
    exit;
  end;
  if replycid=-1 then
    Log('Nicht verbunden.')
  else
    with QueuedPacket do begin
      id    := replycid;
      case key of
        #27 : begin
                replycid:=cidclientabort;
                daten:='';
              end;
        #13 : key:=TIkeyEnter;
        'O' : key:=TIkeyUp;
        'U' : key:=TIkeyDown;
        'L' : if replycid=32 then
                key:=TIkeyMenuL
              else
                key:=TIkeyLeft;
        'R' : if replycid=32 then
                key:=TIkeyMenuR
              else
                key:=TIkeyRight;
        else  key:=chr(ord(key)-ord('0'));
      end;
      daten := key;
    end;
  EditInput.Text:='';
end;


procedure TFormTiSim.EditEditFieldKeyPress(Sender: TObject; var Key: Char);
begin
  if not(key in [#13,#27]) then exit; //weder Enter noch Escape
  with QueuedPacket do begin
    id    := replycid;
    if key=#13 then daten:=#0
      else daten:=#1; //key=#27=escape : Eingabe mit Escape beendet
    daten := daten + chr(length(EditEditField.Text))+ EditEditField.Text;
  end;
end;


procedure TFormTiSim.CmdSilentDisconnectClick(Sender: TObject);
//'disconnect' without disconnecting (debug)
begin
  myaddr:=$FF;
  EditAddress.Text:='$FF';
  CmdConnect.Caption:='&Connect';
  RGTIType.Enabled:=true;
end;


procedure TFormTiSim.EditUsernameKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then
    CmdConnect.Click;
end;


procedure TFormTiSim.RGTITypeClick(Sender: TObject);
//change ti type
begin
  case RGTIType.ItemIndex of
    0 : begin
      mytitype := TI82;
      Caption  := 'TIsim 82';
    end;
    1 : begin
      mytitype := TI86;
      Caption  := 'TIsim 86';
    end;
  end;
  MemoTIScr.Width := TIScrWidthInChars[mytitype] * 8 + 8;
  MemoLog.Left    := MemoTIScr.Width;
  MemoLog.Width   := 394-MemoTIScr.Width;
  TiCLS;
end;

end.
